
package  UserInt;

import  java.awt.CheckboxMenuItem;
import  java.util.*;

/**********************************************************************
  checkbox menuitem group (for menus in the menubar)
  **********************************************************************/
// courtesy of Sean Luke (seanl@cs.umd.edu)

public class CheckboxMenuItemGroup extends Object
{
    private  Vector v;

    public CheckboxMenuItemGroup()
    {
        v = new Vector();
    }

    public Vector getCheckboxMIGroup()
    {
        return  v;
    }

    public void add (CheckboxMenuItem i)
    {
        v.addElement(i);
    }

    // the one in the group that will be set to true is returned.
    //
    public CheckboxMenuItem add (String[] checkboxMINames, int setPosition)
    {
        CheckboxMenuItem  defaultMI = null;

        for (int i = 0; i < checkboxMINames.length; i++)
        {
            String  name = checkboxMINames[i];
            CheckboxMenuItem cmi = new CheckboxMenuItem(name);
            v.addElement (cmi);
            if (i == setPosition)
            defaultMI = cmi;
        }
        return   defaultMI;
    }

  /** Unsets all items in the group except for the one specified. */
    public void unsetOthers (CheckboxMenuItem i)
    {
        Enumeration e = v.elements();
        CheckboxMenuItem vect_item;
        while(e.hasMoreElements())
        {
            vect_item = ((CheckboxMenuItem)(e.nextElement()));
            if (vect_item != i)
	      vect_item.setState(false);
        }
    }

  /** Sets the specified menu item and unsets all others in the group. */
    public void set (CheckboxMenuItem i)
    {
        unsetOthers(i);
        i.setState(true);
    }
}
